4 ### expected to be run as root
8 #################### global vars
10 DB_CONF_FILE=@DBDIR@/conf.db
11 DB_SCHEMA=@pkgdatadir@/vswitch.ovsschema
12 DB_LOG=@LOGDIR@/ovs-db.log
14 DB_SOCKET=$RUN_DIR/db.sock
16 SWITCH_LOG=@LOGDIR@/ovs-switch.log
18 #################### helper functions
20 function kill_pltap_ovs () {
21 killall pltap-ovs 2>/dev/null || :
31 err_msg="$COMMAND $SUBCOMMAND $(echo $params | perl -pe 's/\S+/<$&>/g')"
33 [[ -z "$@" ]] && error "$err_msg"
34 pname=$(echo -n $p|perl -pe 's/\W/_/g')
35 eval $pname="$1"; shift
37 [[ -n "$@" ]] && error "$err_msg"
40 function is_switch_running {
41 ovs-appctl --target=ovs-vswitchd version >& /dev/null
44 function is_db_running {
45 ovs-appctl --target=ovsdb-server version >& /dev/null
50 echo $(ip addr show to "$IP/32" | perl -ne '/^\s*\d+:\s*([\w-]+):/ && print $1')
53 function wait_server () {
58 expire=$(($(date +%s) + $timeout))
60 ## wait for it to be up - xxx todo - could use a timeout of some kind
61 while [ ! -f "$pid_file" ]; do
62 echo "Waiting for $server_name to start... $(($expire - $(date +%s)))s left" >&2
64 [ $(date +%s) -ge $expire ] && return 1
69 function wait_device () {
73 expire=$(($(date +%s) + $timeout))
75 while ! ip link show up | egrep -q "^[0-9]+: +$tapname:"; do
76 echo "Waiting for $tapname to come UP...$(($expire - $(date +%s)))s left" >&2
78 [ $(date +%s) -ge $expire ] && return 1
83 ######################################## startup
84 function start_db () {
88 conf_dir=$(dirname $DB_CONF_FILE)
89 [ -d $conf_dir ] || mkdir -p $conf_dir
90 [ -f $DB_CONF_FILE ] || ovsdb-tool create $DB_CONF_FILE $DB_SCHEMA
93 [ -d $RUN_DIR ] || mkdir -p $RUN_DIR
96 [ -f $DB_CONF_FILE ] || { echo "Could not initialize $DB_CONF_FILE - exiting" ; exit 1 ; }
97 [ -d $RUN_DIR ] || { echo "Could not initialize $RUN_DIR - exiting" ; exit 1 ; }
100 if [ ! -f "$RUN_DIR/ovsdb-server.pid" ]; then
101 ovsdb-server $DB_CONF_FILE \
102 --remote=punix:$DB_SOCKET \
103 --remote=db:Open_vSwitch,manager_options \
104 --private-key=db:SSL,private_key \
105 --certificate=db:SSL,certificate \
106 --bootstrap-ca-cert=db:SSL,ca_cert \
109 --detach >& /dev/null
111 echo 'ovsdb-server appears to be running already, *not* starting'
113 wait_server $RUN_DIR/ovsdb-server.pid ovsdb-server 30
116 function start_switch () {
119 # ensure ovsdb-server is running
120 is_db_running || { echo "ovsdb-server not running" >&2 ; exit 1 ; }
122 if [ ! -f "$RUN_DIR/ovs-vswitchd.pid" ] ; then
125 --log-file=$SWITCH_LOG \
127 unix:$DB_SOCKET >& /dev/null
129 echo 'ovs-vswitchd appears to be running already, *not* starting'
131 wait_server $RUN_DIR/ovs-vswitchd.pid ovs-vswitchd 30
134 function stop_db () {
135 ovs-appctl --target=ovsdb-server exit || :
138 function stop_switch () {
139 ovs-appctl --target=ovs-vswitchd exit || :
144 [ -n "$pids" ] && ps $pids
157 #################### create functions
158 function create_bridge () {
160 get_params "bridge IP/PREFIX" "$1" "$2"
164 PREFIX=${IP_PREFIX#*/}
167 if ! is_switch_running; then
168 # we can create the bridge even if ovs-vswitchd is not running,
169 # but we need a running ovsdb-server
170 is_db_running || { echo "ovsdb-server not running" >&2; exit 1; }
176 ovs-vsctl --db=unix:$DB_SOCKET $W -- --may-exist add-br "$bridge" \
177 -- set bridge "$bridge" datapath_type=planetlab \
178 -- set interface "$bridge" options:local_ip="$IP" option:local_netmask="$PREFIX" \
182 function create_port () {
184 get_params "bridge port" "$@"
187 if ! is_switch_running; then
188 # we can create the port even if ovs-vswitchd is not running,
189 # but we need a running ovsdb-server
190 is_db_running || { echo "ovsdb-server not running" >&2; exit 1; }
195 ovs-vsctl --db=unix:$DB_SOCKET $W -- --may-exist add-port "$bridge" "$port" \
196 -- set interface "$port" type=tunnel
199 function get_local_endpoint () {
201 get_params "local_port" "$@"
203 is_switch_running || { echo "ovs-vswitchd not running" >&2; exit 1; }
206 ovs-appctl --target=ovs-vswitchd netdev-tunnel/get-port "$local_port"
209 function set_remote_endpoint () {
211 get_params "local_port remote_ip remote_UDP_port" "$@"
214 if ! is_switch_running; then
215 # we can store the info even if ovs-vswitchd is not running,
216 # but we need a running ovsdb-server
217 is_db_running || { echo "ovsdb-server not running" >&2; exit 1; }
222 ovs-vsctl --db=unix:$DB_SOCKET $W set interface $local_port \
223 options:remote_ip=$remote_ip \
224 options:remote_port=$remote_UDP_port
227 function set_controller () {
229 get_params "bridge_name controller" "$@"
231 # ensure ovs-vswitchd is running
232 is_switch_running || { echo "ovs-vswitchd not running" >&2 ; exit 1 ; }
235 ovs-vsctl --db=unix:$DB_SOCKET set-controller "$bridge_name" "$controller"
238 function del_controller () {
240 get_params "bridge_name" "$@"
242 # ensure ovs-vswitchd is running
243 is_switch_running || { echo "ovs-vswitchd not running" >&2 ; exit 1 ; }
246 ovs-vsctl --db=unix:$DB_SOCKET del-controller "$bridge_name"
249 #################### del functions
250 function del_bridge () {
252 get_params "bridge_name" "$@"
255 if ! is_switch_running; then
256 # we can delete the bridge even if ovs-vswitchd is not running,
257 # but we need a running ovsdb-server
258 is_db_running || { echo "ovsdb-server not running" >&2; exit 1; }
262 ovs-vsctl --db=unix:$DB_SOCKET $W -- --if-exists del-br $bridge_name
265 function del_port () {
267 get_params "port" "$@"
270 if ! is_switch_running; then
271 # we can delete the port even if ovs-vswitchd is not running,
272 # but we need a running ovsdb-server
273 is_db_running || { echo "ovsdb-server not running" >&2; exit 1; }
277 ovs-vsctl --db=unix:$DB_SOCKET $W -- --if-exists del-port "$port"
284 is_db_running || { echo "ovsdb-server not running" >&2; exit 1; }
286 ovs-vsctl --db=unix:$DB_SOCKET show
289 function get_local_ip () {
291 get_params "bridge" "$@"
294 ovs-vsctl --db=unix:$DB_SOCKET br-exists "$bridge" || return
295 local ip=$(ovs-vsctl get interface "$bridge" options:local_ip)
296 local netmask=$(ovs-vsctl get interface "$bridge" options:local_netmask)
297 eval echo $ip/$netmask
300 function get_local_links () {
302 get_params "bridge" "$@"
305 ovs-vsctl --db=unix:$DB_SOCKET br-exists "$bridge" || return
306 ovs-vsctl --db=unix:$DB_SOCKET list-ifaces "$bridge"
309 function get_mac () {
311 get_params "bridge" "$@"
314 local tap=$(ovs-appctl netdev-pltap/get-tapname "$bridge")
315 ifconfig "$tap" | awk '/HWaddr/ { print $5 }'
318 ### for demos - connect to an ndnmap deployment to visualize links bandwidth
319 # this expects 3 arguments
320 # an interface name, L<id1>-<id2> based on your ids in conf.mk
321 # the hostname for a ndnmap deployment
322 # a linkid, this is the id that this link has in your ndnmap scenario (hard-coded in some json file)
323 # this one-shot function writes the current statistics onto the ndnmap site
324 # it needs to be called regularly so that ndnmap can do the bw computations
325 # would make sense for the caller to redirect stderr onto some relevant location
326 function gmap_probe_once () {
330 rx_bytes=$(ovs-appctl netdev-tunnel/get-rx-bytes $iface)
331 tx_bytes=$(ovs-appctl netdev-tunnel/get-tx-bytes $iface)
332 rx_bits=$(($rx_bytes*8))
333 tx_bits=$(($tx_bytes*8))
334 now=$(date +%s).$(date +%N)
335 trigger=http://${hostname}/bw/${linkid}/${now}/${rx_bits}/${tx_bits}
336 # curl -s -L $trigger | grep -q "Got it" || echo Missed event with $trigger
338 curl -s -L $trigger >& /dev/null
341 ### the front end, manages pid and so on
342 function gmap_probe () {
347 [ -z "$looptime" ] && looptime=1
348 pid_file=/var/run/openvswitch/gmap-$iface.pid
349 if [ -f $pid_file ] ; then
351 [ -n "$pid" ] && kill $pid >& /dev/null
354 # close std fds so that ssh invokations can return
358 gmap_probe_once $iface $hostname $linkid
361 # this is the pid for the background process
366 SUPPORTED_SUBCOMMANDS="start stop status
367 start_db stop_db start_switch stop_switch
368 create_bridge create_port del_bridge del_port
369 show get_local_endpoint set_remote_endpoint
370 set_controller del_controller gmap_probe
371 get_local_ip get_local_links get_mac"
374 message="Usage: $COMMAND <subcommand> ...
375 Supported subcommands are (dash or underscore is the same):
376 $SUPPORTED_SUBCOMMANDS"
377 [[ -z "$@" ]] && error "$message"
380 # support dashes instead of underscores
381 SUBCOMMAND=$(echo $SUBCOMMAND | sed -e s,-,_,g)
383 for supported in $SUPPORTED_SUBCOMMANDS; do [ "$SUBCOMMAND" = "$supported" ] && found=yes; done
385 [ -z "$found" ] && error $message